#ifndef RENDERER_H_
#define RENDERER_H_

#include <SDL/SDL_opengl.h>
#include <boost/shared_ptr.hpp>
#include <string>
#include "Types.h"

class Renderer {
public:
    Renderer() :
        m_tile_width(.1), m_tile_height(.1) {
    }

    double GetTileWidth() const { return m_tile_width; }
    double GetTileHeight() const { return m_tile_height; }

    void SetTileSize(double width, double height);

    void LoadTexture(const std::string & filename);
    void DrawSprite(double tex_x, double tex_y, double tex_w, double tex_h, double pos_x, double pos_y,
                    double width, double height, DL::DisplayLayer layer);

private:
    GLuint m_texture;
    double m_tile_width;
    double m_tile_height;
};

typedef boost::shared_ptr<Renderer> RendererPtr;

#endif /* RENDERER_H_ */
